## cvmfs 2.13.3+ubuntu24.04

=== test/unittests/CMakeLists.txt ===
#
# This file is part of the CernVM File System
#

if (BUILD_UNITTESTS OR BUILD_UNITTESTS_DEBUG)

# GoogleTest
set(GOOGLETEST_MIN_VERSION "1.10.0")
if(USE_EXTERNAL_GOOGLETEST)
  if (USE_EXTERNAL_GOOGLETEST STREQUAL AUTO)
    find_package(GTest ${GOOGLETEST_MIN_VERSION})
  else()
    find_package(GTest ${GOOGLETEST_MIN_VERSION} REQUIRED)
  endif()
endif()

if(NOT GTest_FOUND)
  message(STATUS "Fetching local copy of Googletest library v1.17.0 for unit-tests...")
  Include(FetchContent)
  set(INSTALL_GTEST OFF)

  # Check if local file exists first
  set(GOOGLETEST_LOCAL_PATH "${PROJECT_SOURCE_DIR}/externals/googletest-1.17.0.tar.gz")

  if(EXISTS "${GOOGLETEST_LOCAL_PATH}")
      message(STATUS "Using local GoogleTest archive: ${GOOGLETEST_LOCAL_PATH}")
      FetchContent_Declare(
          GoogleTest
          #DOWNLOAD_EXTRACT_TIMESTAMP TRUE
          DOWNLOAD_DIR ${PROJECT_SOURCE_DIR}/externals
          URL "file://${GOOGLETEST_LOCAL_PATH}"
          URL_HASH MD5=b6f100bc2a5853a48046aa168ececf84
      )
  else()
      message(STATUS "Local GoogleTest archive not found, downloading from remote")
      FetchContent_Declare(
          GoogleTest
          #DOWNLOAD_EXTRACT_TIMESTAMP TRUE
          DOWNLOAD_DIR ${PROJECT_SOURCE_DIR}/externals
          URL https://github.com/google/googletest/releases/download/v1.17.0/googletest-1.17.0.tar.gz
              https://ecsft.cern.ch/dist/cvmfs/build_externals/googletest-1.17.0.tar.gz
          URL_HASH MD5=b6f100bc2a5853a48046aa168ececf84
      )
  endif()

FetchContent_MakeAvailable(GoogleTest)
endif()
get_target_property(GTEST_INCLUDE_DIRS GTest::gtest INCLUDE_DIRECTORIES)
set (INCLUDE_DIRECTORIES ${INCLUDE_DIRECTORIES} ${GTEST_INCLUDE_DIRS})

set (CVMFS_SOURCE_DIR "${CMAKE_SOURCE_DIR}/cvmfs")
set (CVMFS_UNITTEST_COMMON_CFLAGS "-DCVMFS_LIBCVMFS -D_FILE_OFFSET_BITS=64 -fexceptions")

#
# Protobuf generated sources
#
set_source_files_properties (cache.pb.h cache.pb.cc PROPERTIES GENERATED true)
add_custom_command (OUTPUT cache.pb.h cache.pb.cc
                    COMMAND ${PROTOBUF_PROTOC_EXECUTABLE} --cpp_out=.
                            ${CVMFS_SOURCE_DIR}/cache.proto
                            -I${CVMFS_SOURCE_DIR}
                    DEPENDS ${PROTOBUF_PROTOC_EXECUTABLE}
                            ${CVMFS_SOURCE_DIR}/cache.proto
                    COMMENT "Generating protobuf sources")
add_custom_target (cache.pb.generated-unittests DEPENDS cache.pb.h cache.pb.cc)

include_directories (${CMAKE_CURRENT_BINARY_DIR}
                     ${CMAKE_CURRENT_SOURCE_DIR}/../common
                     ${INCLUDE_DIRECTORIES})



#
# cvmfs_test_cache
#
if (BUILD_LIBCVMFS_CACHE)
  add_executable (cvmfs_test_cache
                  cache.pb.cc cache.pb.h
                  cache_plugin/main.cc
                  cache_plugin/t_cache_plugin.cc

                  ${CVMFS_SOURCE_DIR}/cache.cc
                  ${CVMFS_SOURCE_DIR}/cache_extern.cc
                  ${CVMFS_SOURCE_DIR}/cache_transport.cc
                  ${CVMFS_SOURCE_DIR}/compression/compression.cc
                  ${CVMFS_SOURCE_DIR}/manifest.cc
                  ${CVMFS_SOURCE_DIR}/quota.cc
  )
  add_dependencies (cvmfs_test_cache cache.pb.generated-unittests)
  set_target_properties (cvmfs_test_cache PROPERTIES
                         COMPILE_FLAGS "${CVMFS_UNITTEST_COMMON_CFLAGS}"
  )
  target_link_libraries (cvmfs_test_cache
                         cvmfs_crypto
                         cvmfs_util
                         GTest::gtest
                         ${ZLIB_LIBRARIES}
                         ${RT_LIBRARY}
                         ${PROTOBUF_LITE_LIBRARY}
                         pthread
  )
  if (INSTALL_UNITTESTS)
    install (
      TARGETS      cvmfs_test_cache
      RUNTIME
      DESTINATION  bin
    )
  endif ()
endif (BUILD_LIBCVMFS_CACHE)



#
# cvmfs_test_shrinkwrap
#
if (BUILD_SHRINKWRAP)
  add_executable (cvmfs_test_shrinkwrap
                  shrinkwrap/main.cc
                  ../common/env.cc

                  shrinkwrap/t_fs_traversal_interface.cc
                  shrinkwrap/t_fs_posix.cc
                  shrinkwrap/t_spec_tree.cc
                  shrinkwrap/testutil_shrinkwrap.cc

                  ${CVMFS_SOURCE_DIR}/shrinkwrap/fs_traversal.cc
                  ${CVMFS_SOURCE_DIR}/shrinkwrap/posix/data_dir_mgmt.cc
                  ${CVMFS_SOURCE_DIR}/shrinkwrap/posix/garbage_collector.cc
                  ${CVMFS_SOURCE_DIR}/shrinkwrap/posix/helpers.cc
                  ${CVMFS_SOURCE_DIR}/shrinkwrap/posix/interface.cc
                  ${CVMFS_SOURCE_DIR}/shrinkwrap/fs_traversal_libcvmfs.cc
                  ${CVMFS_SOURCE_DIR}/shrinkwrap/util.cc
                  ${CVMFS_SOURCE_DIR}/shrinkwrap/spec_tree.cc

                  ${CVMFS_SOURCE_DIR}/statistics.cc
                  ${CVMFS_SOURCE_DIR}/xattr.cc
  )
  set_target_properties (cvmfs_test_shrinkwrap PROPERTIES
                         COMPILE_FLAGS "${CVMFS_UNITTEST_COMMON_CFLAGS}"
  )
  target_link_libraries (cvmfs_test_shrinkwrap
                         cvmfs_client
                         cvmfs_crypto
                         cvmfs_util
                         GTest::gtest
                         pthread
                         dl
  )
  if (INSTALL_UNITTESTS)
    install (
      TARGETS       cvmfs_test_shrinkwrap
      RUNTIME
      DESTINATION   bin
    )
  endif ()
endif (BUILD_SHRINKWRAP)



#
# cvmfs_test_publish
#
if (BUILD_SERVER)
  set (CVMFS_UNITTEST_SERVER_SOURCES
       c_http_server.cc
       publish/c_repository.cc
       publish/main.cc
       publish/t_command.cc
       publish/t_env.cc
       publish/t_diff.cc
       publish/t_session.cc
       publish/t_repository.cc
       publish/t_settings.cc
       publish/t_transaction.cc
       publish/t_util.cc

       ../common/env.cc

       ${CVMFS_SOURCE_DIR}/publish/cmd_help.cc
       ${CVMFS_SOURCE_DIR}/publish/cmd_mkfs.cc
       ${CVMFS_SOURCE_DIR}/publish/cmd_util.cc
       ${CVMFS_SOURCE_DIR}/publish/cmd_zpipe.cc
       ${CVMFS_SOURCE_DIR}/publish/command.cc
       ${CVMFS_SOURCE_DIR}/publish/except.cc
       ${CVMFS_SOURCE_DIR}/publish/repository.cc
       ${CVMFS_SOURCE_DIR}/publish/repository_abort.cc
       ${CVMFS_SOURCE_DIR}/publish/repository_env.cc
       ${CVMFS_SOURCE_DIR}/publish/repository_diff.cc
       ${CVMFS_SOURCE_DIR}/publish/repository_managed.cc
       ${CVMFS_SOURCE_DIR}/publish/repository_session.cc
       ${CVMFS_SOURCE_DIR}/publish/repository_tags.cc
       ${CVMFS_SOURCE_DIR}/publish/repository_transaction.cc
       ${CVMFS_SOURCE_DIR}/publish/repository_util.cc
       ${CVMFS_SOURCE_DIR}/publish/settings.cc

       ${CVMFS_SOURCE_DIR}/backoff.cc
       ${CVMFS_SOURCE_DIR}/catalog.cc
       ${CVMFS_SOURCE_DIR}/catalog_counters.cc
       ${CVMFS_SOURCE_DIR}/catalog_downloader.cc
       ${CVMFS_SOURCE_DIR}/catalog_sql.cc
       ${CVMFS_SOURCE_DIR}/catalog_rw.cc
       ${CVMFS_SOURCE_DIR}/catalog_mgr_ro.cc
       ${CVMFS_SOURCE_DIR}/catalog_mgr_rw.cc
       ${CVMFS_SOURCE_DIR}/catalog_virtual.cc
       ${CVMFS_SOURCE_DIR}/compression/compression.cc
       ${CVMFS_SOURCE_DIR}/directory_entry.cc
       ${CVMFS_SOURCE_DIR}/gateway_util.cc
       ${CVMFS_SOURCE_DIR}/globals.cc
       ${CVMFS_SOURCE_DIR}/history_sql.cc
       ${CVMFS_SOURCE_DIR}/history_sqlite.cc
       ${CVMFS_SOURCE_DIR}/ingestion/chunk_detector.cc
       ${CVMFS_SOURCE_DIR}/ingestion/item.cc
       ${CVMFS_SOURCE_DIR}/ingestion/item_mem.cc
       ${CVMFS_SOURCE_DIR}/ingestion/pipeline.cc
       ${CVMFS_SOURCE_DIR}/ingestion/task_chunk.cc
       ${CVMFS_SOURCE_DIR}/ingestion/task_compress.cc
       ${CVMFS_SOURCE_DIR}/ingestion/task_hash.cc
       ${CVMFS_SOURCE_DIR}/ingestion/task_read.cc
       ${CVMFS_SOURCE_DIR}/ingestion/task_register.cc
       ${CVMFS_SOURCE_DIR}/ingestion/task_write.cc
       ${CVMFS_SOURCE_DIR}/json_document.cc
       ${CVMFS_SOURCE_DIR}/malloc_arena.cc
       ${CVMFS_SOURCE_DIR}/manifest.cc
       ${CVMFS_SOURCE_DIR}/manifest_fetch.cc
       ${CVMFS_SOURCE_DIR}/network/dns.cc
       ${CVMFS_SOURCE_DIR}/network/download.cc
       ${CVMFS_SOURCE_DIR}/network/jobinfo.cc
       ${CVMFS_SOURCE_DIR}/network/s3fanout.cc
       ${CVMFS_SOURCE_DIR}/network/sink_file.cc
       ${CVMFS_SOURCE_DIR}/network/sink_mem.cc
       ${CVMFS_SOURCE_DIR}/network/sink_path.cc
       ${CVMFS_SOURCE_DIR}/options.cc
       ${CVMFS_SOURCE_DIR}/pack.cc
       ${CVMFS_SOURCE_DIR}/reflog.cc
       ${CVMFS_SOURCE_DIR}/reflog_sql.cc
       ${CVMFS_SOURCE_DIR}/sanitizer.cc
       ${CVMFS_SOURCE_DIR}/session_context.cc
       ${CVMFS_SOURCE_DIR}/shortstring.cc
       ${CVMFS_SOURCE_DIR}/sql.cc
       ${CVMFS_SOURCE_DIR}/sqlitemem.cc
       ${CVMFS_SOURCE_DIR}/ssl.cc
       ${CVMFS_SOURCE_DIR}/statistics.cc
       ${CVMFS_SOURCE_DIR}/swissknife_assistant.cc
       ${CVMFS_SOURCE_DIR}/swissknife_lease_curl.cc
       ${CVMFS_SOURCE_DIR}/sync_item.cc
       ${CVMFS_SOURCE_DIR}/sync_item_dummy.cc
       ${CVMFS_SOURCE_DIR}/sync_item_tar.cc
       ${CVMFS_SOURCE_DIR}/sync_mediator.cc
       ${CVMFS_SOURCE_DIR}/sync_union.cc
       ${CVMFS_SOURCE_DIR}/sync_union_aufs.cc
       ${CVMFS_SOURCE_DIR}/sync_union_overlayfs.cc
       ${CVMFS_SOURCE_DIR}/sync_union_tarball.cc
       ${CVMFS_SOURCE_DIR}/upload.cc
       ${CVMFS_SOURCE_DIR}/upload_facility.cc
       ${CVMFS_SOURCE_DIR}/upload_gateway.cc
       ${CVMFS_SOURCE_DIR}/upload_local.cc
       ${CVMFS_SOURCE_DIR}/upload_s3.cc
       ${CVMFS_SOURCE_DIR}/upload_spooler_definition.cc
       ${CVMFS_SOURCE_DIR}/whitelist.cc
       ${CVMFS_SOURCE_DIR}/xattr.cc
  )
  set (CVMFS_UNITTEST_SERVER_LINK_LIBRARIES "")
  list (APPEND CVMFS_UNITTEST_SERVER_LINK_LIBRARIES
        GTest::gtest
        ${OPENSSL_LIBRARIES}
        ${CURL_LIBRARIES}
        ${CARES_LIBRARIES} ${CARES_LDFLAGS}
        ${OPENSSL_LIBRARIES}
        ${SQLITE3_LIBRARY}
        ${ZLIB_LIBRARIES}
        ${VJSON_LIBRARIES}
        ${CAP_LIBRARIES}
        ${LibArchive_LIBRARY}
        ${RT_LIBRARY}
        pthread
        dl
  )
  add_executable (cvmfs_test_publish ${CVMFS_UNITTEST_SERVER_SOURCES})

  set_target_properties (cvmfs_test_publish PROPERTIES
                         COMPILE_FLAGS "${CVMFS_UNITTEST_COMMON_CFLAGS}"
  )

  target_link_libraries (cvmfs_test_publish
                         cvmfs_crypto
                         cvmfs_util
                         ${CVMFS_UNITTEST_SERVER_LINK_LIBRARIES})

  if (INSTALL_UNITTESTS)
    install (
      TARGETS      cvmfs_test_publish
      RUNTIME
      DESTINATION  bin
    )
  endif ()

  if (BUILD_UNITTESTS_DEBUG)
  add_executable (cvmfs_test_publish_debug ${CVMFS_UNITTEST_SERVER_SOURCES})
  set_target_properties (cvmfs_test_publish_debug PROPERTIES
                         COMPILE_FLAGS "${CVMFS_UNITTEST_COMMON_CFLAGS} -O0 -DDEBUGMSG"
  )
  target_link_libraries (cvmfs_test_publish_debug
                         cvmfs_crypto_debug
                         cvmfs_util_debug
                         ${CVMFS_UNITTEST_SERVER_LINK_LIBRARIES})

  if (INSTALL_UNITTESTS)
    install (
      TARGETS      cvmfs_test_publish_debug
      RUNTIME
      DESTINATION  bin
    )
  endif ()
endif ()
endif (BUILD_SERVER)




#
# unit test files
#
set(CVMFS_UNITTEST_SOURCES
  # test steering
  main.cc

  # test utility functions
  ../common/env.cc
  ../common/testutil.cc
  ../common/catalog_test_tools.cc

  t_acl.cc
  t_assert_or_log.cc
  t_atomic.cc
  t_authz_fetch.cc
  t_authz_session.cc
  t_backoff.cc
  t_base64.cc
  t_bigqueue.cc
  t_bigvector.cc
  t_blocking_counter.cc
  t_cache.cc
  t_cache_extern.cc
  t_cache_ram.cc
  t_cache_stream.cc
  t_cache_tiered.cc
  t_callbacks.cc
  t_catalog.cc
  t_catalog_counters.cc
  t_catalog_merge_tool.cc
  t_catalog_mgr.cc
  t_catalog_mgr_client.cc
  t_catalog_mgr_rw.cc
  t_catalog_sql.cc
  t_catalog_traversal.cc
  t_catalog_virtual.cc
  t_chunk_detectors.cc
  t_clientctx.cc
  t_compression.cc
  t_compressor.cc
  t_dirtab.cc
  t_dns.cc
  t_download.cc
  t_encrypt.cc
  t_fd_table.cc
  t_fence.cc
  t_fetch.cc
  t_file_backed_buffer.cc

=== debian/changelog ===
cvmfs (2.13.3+ubuntu24.04) UNRELEASED; urgency=medium

  * bumped upstream version number

 -- Jakob Blomer <jblomer@cern.ch>  Thu, 23 Oct 2025 17:33:55 +0000

=== debian/control ===
Source: cvmfs
Section: utils
Priority: extra
Maintainer: Jakob Blomer <jblomer@cern.ch>
Build-Depends:
 libfuse3-dev (>= 3.3.0),
#BUILD_LIBFUSE2 libfuse-dev,
 debhelper (>= 9),
 autotools-dev,
 cmake,
 cpio,
 help2man,
 libcap-dev,
 libssl-dev,
 libattr1-dev,
 libz-dev,
 patch,
 pkg-config,
 python3-dev,
 python3-setuptools,
 unzip,
 uuid-dev
Standards-Version: 3.9.6.1
Homepage: http://cernvm.cern.ch/portal/filesystem

Package: cvmfs
Architecture: amd64 armhf arm64
Depends:
 cvmfs-config-default | cvmfs-config,
 cvmfs-fuse3 (= ${binary:Version}),
#BUILD_LIBFUSE2 fuse,
 gawk,
 psmisc,
 lsof,
 attr,
 zlib1g,
 gdb,
 uuid-dev,
 uuid,
 adduser,
 cvmfs-libs (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Recommends:
 autofs (>= 5.1.2)
Homepage: http://cernvm.cern.ch
Description: CernVM File System
 HTTP File System for Distributing Software to CernVM.

Package: cvmfs-libs
Architecture: amd64 armhf arm64
Depends: ${misc:Depends}
Homepage: http://cernvm.cern.ch
Description: CernVM-FS common libraries
 Common utility libraries for CernVM-FS packages.

Package: cvmfs-server
Architecture: amd64 armhf arm64
Depends:
# TODO(vavolkl): remove fuse3 once server fstab is modernized
 fuse3,
 psmisc,
 curl,
 attr,
 openssl,
 libcap2,
 libcap2-bin,
 lsof,
 rsync,
 jq,
 usbutils,
 sqlite3,
 tar,
 cvmfs-libs (= ${binary:Version}),
 cvmfs-fuse3 (= ${binary:Version}),
 ${misc:Depends}
Recommends:
 apache2,
 logrotate
Conflicts: cvmfs-server (<< 2.1)
Homepage: http://cernvm.cern.ch
Description: CernVM-FS server utilities
 HTTP File System Repository Server for Distributing Software to CernVM.

Package: cvmfs-dev
Architecture: amd64 armhf arm64
Depends:
 openssl,
 ${misc:Depends}
Homepage: http://cernvm.cern.ch
Description: CernVM-FS client library
 CernVM-FS static client library

Package: cvmfs-shrinkwrap
Architecture: amd64 armhf arm64
Depends:
 openssl,
 python3,
 cvmfs-libs (= ${binary:Version}),
 ${misc:Depends}
Homepage: http://cernvm.cern.ch
Description: CernVM-FS shrinkwrap utility to export /cvmfs file system trees
 CernVM-FS shrinkwrap utility to export /cvmfs file system trees into container images.

Package: cvmfs-fuse3
Architecture: amd64 armhf arm64
Depends:
 cvmfs-libs (= ${binary:Version}),
 ${shlibs:Depends}
Homepage: http://cernvm.cern.ch
Description: CernVM File System fuse3 libraries
 Shared libraries implementing the CernVM-FS fuse module based on libfuse3

#GATEWAY-BEGIN
Package: cvmfs-gateway
Architecture: amd64
Depends:
 psmisc,
 cvmfs-server,
 ${misc:Depends}
Homepage: http://cernvm.cern.ch
Description: CernVM-FS Repository Gateway
 The CernVM-FS repository gateway service enables multiple remote publishers to write to the same repository.
#GATEWAY-END

#SNAPSHOTTER-BEGIN
Package: cvmfs-snapshotter
Architecture: amd64 arm64
Depends:
 psmisc,
 cvmfs,
 ${misc:Depends}
Homepage: http://cernvm.cern.ch
Description: CernVM-FS Snapshotter
 A containerd snapshotter service for lazy-loading of containers from CVMFS
#SNAPSHOTTER-END

## cvmfs 2.13.3+ubuntu25.10

=== debian/changelog ===
cvmfs (2.13.3+ubuntu25.10) UNRELEASED; urgency=medium

  * bumped upstream version number

 -- Jakob Blomer <jblomer@cern.ch>  Wed, 10 Dec 2025 16:55:25 +0000
